public abstract class BaseState
{
	protected PlayerController controller;

	public BaseState(PlayerController player)
	{
		controller = player;
	}

	public abstract void OnEnter();
	public abstract BaseState Update();
	public abstract void OnExit();

	public abstract BaseState HandleInput();
}